/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.mangue.client.gui.cir;

import java.awt.BorderLayout;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.mangue.common.utilities.CocktailConstantes;
import org.cocktail.mangue.common.utilities.CocktailIcones;
import org.cocktail.mangue.modele.FicheSynthese;

import com.webobjects.eointerface.EODisplayGroup;


/**
 *
 * @author  cpinsard
 */
public class SyntheseCarriereCIRView extends JFrame {

    /**
	 * 
	 */
	private static final long serialVersionUID = -6195866169790317637L;

	protected EODisplayGroup eod;
	protected ZEOTable myEOTable;
	protected ZEOTableModel myTableModel;
	protected TableSorter myTableSorter;

	/** Creates new form TemplateJDialog */
    public SyntheseCarriereCIRView(java.awt.Frame parent, boolean modal, EODisplayGroup dg) {
       // super(parent, modal);
    	
    	eod = dg;
    	
        initComponents();
        initGui();
        
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        tfTitre = new javax.swing.JTextField();
        viewSyntheseCarriereCIR = new javax.swing.JPanel();
        viewTableSynthese = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        tfDateCertification = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        tfDateVerification = new javax.swing.JTextField();
        btnValiderCarriere = new javax.swing.JButton();
        tfDateCompletude = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        btnImprimerFiche = new javax.swing.JButton();
        tfMessage = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("GESTION DES ROLES");

        tfTitre.setBackground(new java.awt.Color(153, 153, 255));
        tfTitre.setEditable(false);
        tfTitre.setFont(new java.awt.Font("Times New Roman", 0, 14));
        tfTitre.setForeground(new java.awt.Color(255, 255, 204));
        tfTitre.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfTitre.setText("SYNTHESE CARRIERE CIR");
        tfTitre.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        tfTitre.setFocusable(false);
        tfTitre.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tfTitreActionPerformed(evt);
            }
        });

        viewSyntheseCarriereCIR.setPreferredSize(new java.awt.Dimension(500, 557));

        viewTableSynthese.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        viewTableSynthese.setLayout(new java.awt.CardLayout());

        jLabel3.setText("Date Certification Identité");

        tfDateCertification.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfDateCertification.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tfDateCertificationActionPerformed(evt);
            }
        });

        jLabel2.setText("Date de vérification du dossier :");

        tfDateVerification.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfDateVerification.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tfDateVerificationActionPerformed(evt);
            }
        });

        btnValiderCarriere.setText("Valider Saisie");
        btnValiderCarriere.setToolTipText("Enregistrement des dates de complétude et vérification");
        btnValiderCarriere.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnValiderCarriereActionPerformed(evt);
            }
        });

        tfDateCompletude.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfDateCompletude.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tfDateCompletudeActionPerformed(evt);
            }
        });

        jLabel1.setText("Date Complétude Carrière :");

        btnImprimerFiche.setToolTipText("Edition d'une fiche CIR individuelle");

        tfMessage.setEditable(false);
        tfMessage.setForeground(new java.awt.Color(255, 51, 51));
        tfMessage.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfMessage.setBorder(null);
        tfMessage.setFocusable(false);
        tfMessage.setRequestFocusEnabled(false);
        tfMessage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tfMessageActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(tfMessage, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 856, Short.MAX_VALUE)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(btnImprimerFiche, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 45, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(18, 18, 18)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                .add(jPanel1Layout.createSequentialGroup()
                                    .add(jLabel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                    .add(tfDateCertification, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 115, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .add(jPanel1Layout.createSequentialGroup()
                                    .add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 186, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                    .add(tfDateVerification, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 115, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                            .add(jPanel1Layout.createSequentialGroup()
                                .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 185, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(tfDateCompletude, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 115, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(btnValiderCarriere, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 138, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel3)
                            .add(tfDateCertification))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel2)
                            .add(tfDateVerification, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel1)
                            .add(tfDateCompletude, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(btnValiderCarriere)))
                    .add(btnImprimerFiche, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 37, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(tfMessage, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout viewSyntheseCarriereCIRLayout = new org.jdesktop.layout.GroupLayout(viewSyntheseCarriereCIR);
        viewSyntheseCarriereCIR.setLayout(viewSyntheseCarriereCIRLayout);
        viewSyntheseCarriereCIRLayout.setHorizontalGroup(
            viewSyntheseCarriereCIRLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, viewSyntheseCarriereCIRLayout.createSequentialGroup()
                .addContainerGap()
                .add(viewSyntheseCarriereCIRLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, viewTableSynthese, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 876, Short.MAX_VALUE))
                .addContainerGap())
        );
        viewSyntheseCarriereCIRLayout.setVerticalGroup(
            viewSyntheseCarriereCIRLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, viewSyntheseCarriereCIRLayout.createSequentialGroup()
                .addContainerGap()
                .add(viewTableSynthese, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 536, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(tfTitre, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 906, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(viewSyntheseCarriereCIR, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 896, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(tfTitre, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(viewSyntheseCarriereCIR, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 698, Short.MAX_VALUE)
                .addContainerGap())
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-932)/2, (screenSize.height-775)/2, 932, 775);
    }// </editor-fold>//GEN-END:initComponents

    private void tfTitreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tfTitreActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_tfTitreActionPerformed

    private void tfDateCompletudeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tfDateCompletudeActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_tfDateCompletudeActionPerformed

    private void tfDateVerificationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tfDateVerificationActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_tfDateVerificationActionPerformed

    private void tfDateCertificationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tfDateCertificationActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_tfDateCertificationActionPerformed

    private void tfMessageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tfMessageActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_tfMessageActionPerformed

    private void btnValiderCarriereActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnValiderCarriereActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_btnValiderCarriereActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
            	SyntheseCarriereCIRView dialog = new SyntheseCarriereCIRView(new javax.swing.JFrame(), true, null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
					public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnImprimerFiche;
    private javax.swing.JButton btnValiderCarriere;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JTextField tfDateCertification;
    private javax.swing.JTextField tfDateCompletude;
    private javax.swing.JTextField tfDateVerification;
    private javax.swing.JTextField tfMessage;
    private javax.swing.JTextField tfTitre;
    private javax.swing.JPanel viewSyntheseCarriereCIR;
    private javax.swing.JPanel viewTableSynthese;
    // End of variables declaration//GEN-END:variables

    private void initGui() {

    	btnImprimerFiche.setIcon(CocktailIcones.ICON_PRINTER_32);
    	btnValiderCarriere.setIcon(CocktailIcones.ICON_VALID);

		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

		ZEOTableModelColumn col = new ZEOTableModelColumn(eod, FicheSynthese.LL_POPULATION_KEY , "Population", 100);
		col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
		col = new ZEOTableModelColumn(eod, FicheSynthese.STATUT_KEY, "Statut", 60);
		col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod, FicheSynthese.DATE_DEBUT_KEY, "Début", 75);
		col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay(new SimpleDateFormat("dd/MM/yyyy"));
		col.setColumnClass(Date.class);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eod, FicheSynthese.DATE_FIN_KEY, "Fin", 75);
		col.setAlignment(SwingConstants.CENTER);
		col.setFormatDisplay(new SimpleDateFormat("dd/MM/yyyy"));
		col.setColumnClass(Date.class);
    	myCols.add(col);

//		col = new ZEOTableModelColumn(eod, FicheSynthese.CORPS_KEY, "Corps", 75);
//		col.setAlignment(SwingConstants.LEFT);
//    	myCols.add(col);
//		col = new ZEOTableModelColumn(eod, FicheSynthese.GRADE_KEY, "Grade", 75);
//		col.setAlignment(SwingConstants.LEFT);
//    	myCols.add(col);

    	col = new ZEOTableModelColumn(eod, FicheSynthese.QUOTITE_KEY, "Quotite", 75);
		col.setAlignment(SwingConstants.RIGHT);
    	myCols.add(col);

		col = new ZEOTableModelColumn(eod, FicheSynthese.SV_ANNEES_KEY, "Ans", 35);
		col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
		col = new ZEOTableModelColumn(eod, FicheSynthese.SV_MOIS_KEY, "Mois", 35);
		col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
		col = new ZEOTableModelColumn(eod, FicheSynthese.SV_JOURS_KEY, "Jours", 35);
		col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
		col = new ZEOTableModelColumn(eod, FicheSynthese.TEM_PC_ACQUITEES_KEY, "PC", 35);
		col.setAlignment(SwingConstants.CENTER);
    	myCols.add(col);

		myTableModel = new ZEOTableModel(eod, myCols);
		myTableSorter = new TableSorter(myTableModel);

		myEOTable = new ZEOTable(myTableSorter);
		//myEOTable.addListener(myListenerContrat);
		myTableSorter.setTableHeader(myEOTable.getTableHeader());		

		myEOTable.setBackground(CocktailConstantes.BG_COLOR_WHITE);
		myEOTable.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableSynthese.setLayout(new BorderLayout());
		viewTableSynthese.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableSynthese.removeAll();
		viewTableSynthese.add(new JScrollPane(myEOTable), BorderLayout.CENTER);

		
    }

	public ZEOTable getMyEOTable() {
		return myEOTable;
	}

	public void setMyEOTable(ZEOTable myEOTable) {
		this.myEOTable = myEOTable;
	}

	public ZEOTableModel getMyTableModel() {
		return myTableModel;
	}

	public void setMyTableModel(ZEOTableModel myTableModel) {
		this.myTableModel = myTableModel;
	}

	public javax.swing.JButton getBtnValiderCarriere() {
		return btnValiderCarriere;
	}

	public void setBtnValiderCarriere(javax.swing.JButton btnValiderCarriere) {
		this.btnValiderCarriere = btnValiderCarriere;
	}

	public javax.swing.JTextField getTfDateCertification() {
		return tfDateCertification;
	}

	public void setTfDateCertification(javax.swing.JTextField tfDateCertification) {
		this.tfDateCertification = tfDateCertification;
	}

	public javax.swing.JTextField getTfDateCompletude() {
		return tfDateCompletude;
	}

	public void setTfDateCompletude(javax.swing.JTextField tfDateCompletude) {
		this.tfDateCompletude = tfDateCompletude;
	}

	public javax.swing.JTextField getTfDateVerification() {
		return tfDateVerification;
	}

	public void setTfDateVerification(javax.swing.JTextField tfDateVerification) {
		this.tfDateVerification = tfDateVerification;
	}

	public javax.swing.JTextField getTfTitre() {
		return tfTitre;
	}

	public void setTfTitre(javax.swing.JTextField tfTitre) {
		this.tfTitre = tfTitre;
	}

	public javax.swing.JPanel getViewSyntheseCarriereCIR() {
		return viewSyntheseCarriereCIR;
	}

	public void setViewSyntheseCarriereCIR(
			javax.swing.JPanel viewSyntheseCarriereCIR) {
		this.viewSyntheseCarriereCIR = viewSyntheseCarriereCIR;
	}

	public javax.swing.JPanel getViewTableSynthese() {
		return viewTableSynthese;
	}

	public void setViewTableSynthese(javax.swing.JPanel viewTableSynthese) {
		this.viewTableSynthese = viewTableSynthese;
	}

	public javax.swing.JTextField getTfMessage() {
		return tfMessage;
	}

	public void setTfMessage(javax.swing.JTextField tfMessage) {
		this.tfMessage = tfMessage;
	}

	public javax.swing.JButton getBtnImprimerFiche() {
		return btnImprimerFiche;
	}

	public void setBtnImprimerFiche(javax.swing.JButton btnImprimerFiche) {
		this.btnImprimerFiche = btnImprimerFiche;
	}



}
